
addpath /CommonFiles

% Clustering for Filtering (C4F) using 10 sensors for completely unknown
% scenario that contains different types of targets

% Author: Tiancheng Li, tiancheng.li1985@gmail.com, March 20, 2015
% Webpage:https://sites.google.com/site/tianchengli85/O2

% Please refer to the following paper for technical detail
% T. Li, J.M. Corchado,S. Sun and J. Bajo, Clustering for filtering: multi-
% object detection and estimation using multiple/massive sensors, 
% submitted to Information Sciences

% for unknown sensor uncertainty, subfunction Calculate_t_d is therefore needed
% to calculate the multi-estimate distance, subfunction ospa_dist is required
%% parameter setting
clear
close all
Runtime =100;
 MC_C4F = zeros(1,Runtime);
 MC_Tno_C4F=zeros(1,Runtime);
 
MCtimes =10; % For saving time, only 10 trials conducted

% Targets=Trajectory_ghost(Runtime); % generate trajectories for targets
% save Scene
load Scene
 figure  % plot the scene
    hold on
    plot(Targets(1).X0(1,:),Targets(1).X0(2,:),'k-','LineWidth',2);plot(Targets(1).X00(1,:),Targets(1).X00(2,:),'k-','LineWidth',2);
    plot(Targets(1).X1(1,:),Targets(1).X1(2,:),'m.-','LineWidth',2,'MarkerSize',10);
    plot(Targets(1).X2(1,:),Targets(1).X2(3,:),'r-','LineWidth',2);plot(Targets(1).X3(1,:),Targets(1).X3(3,:),'r-','LineWidth',2);plot(Targets(1).X4(1,:),Targets(1).X4(3,:),'r-','LineWidth',2);
    plot(Targets(1).X5(1,:),Targets(1).X5(3,:),'b-','LineWidth',2);plot(Targets(1).X6(1,:),Targets(1).X6(3,:),'b-','LineWidth',2);
    plot(Targets(1).X7(1,:),Targets(1).X7(3,:),'c-','LineWidth',2);plot(Targets(1).X8(1,:),Targets(1).X8(3,:),'c-','LineWidth',2);

    Threshod.Pd = 0.8;     %
    Rate_Clutter =10;
    c=100; % c, p parameters for OSPA
    p=2;
    Dx_noise = 5;
    Dy_noise= 5;
 %     Threshod.sigma = -10;  %  two sigma distance, specified in advance  
    
    flag=1;
  for MC = 1: MCtimes
      
    %%    %==================================main procedure==================
    SensorNo = 10;
    meanTNo_PFs=zeros(1,Runtime);
    %% collecting observations
    for repe=1:SensorNo
        for t=1:Runtime
            x=Targets(t).x;
            clutterNo = poissrnd(Rate_Clutter);
            Y.x = rand(1,clutterNo)*200-100;
            Y.y = rand(1,clutterNo)*200-100;
            if ~isempty(x)
%                 Jp= find(rand(size(distance,2),1)<compute_pD(Model,x));
                Y.x = [Y.x,x(1,:)+ Dx_noise*randn(1,size(x,2))];
                Y.y = [Y.y,x(2,:)+ Dy_noise*randn(1,size(x,2))]; 
            end   
            SENSOR(repe).Observation(t).Y = Y;
        end
    end
    
    Threshod.sigma =Calculate_t_d(SENSOR,SensorNo,Runtime); % online learning the sensor uncertainty
  
    SENSOR_store = SENSOR;
    
    if MC==1
        figure
        % subplot(2,1,1)
        plot(1:Runtime,-Threshod.sigma,'b.:','LineWidth',2)
        set(gca,'FontSize',12); set(gcf,'Color','White'); 
        h1=xlabel('Time');
        h2=ylabel('Estimated parameter \itd');%'{\itk}-means clustering',
        set([h1,h2],'FontSize',14,'FontName','Times new Roman');%set(h3,'FontSize',12,'FontName','Times new Roman');        
        figure
%         hold on
%         for t=1:Runtime
%             subplot(2,1,1),hold on
%             axis([0,100,-100,100])
%              plot(t,SENSOR(repe).Observation(t).Y.x,'gx')
%              subplot(2,1,2),hold on
%              axis([0,100,-100,100])
%              plot(t,SENSOR(repe).Observation(t).Y.y,'gx')
%         end
        subplot(2,1,1),hold on
        plot(Targets(1).X0(1,:),'k-','LineWidth',2);plot(Targets(1).X00(1,:),'k-','LineWidth',2);
        plot(Targets(1).X1(1,:),'m-','LineWidth',2);
        plot(Targets(1).X2(1,:),'r-','LineWidth',2);plot(Targets(1).X3(1,:),'r-','LineWidth',2);plot(Targets(1).X4(1,:),'r-','LineWidth',2);
        plot(Targets(1).X5(1,:),'b-','LineWidth',2);plot(Targets(1).X6(1,:),'b-','LineWidth',2);
        plot(Targets(1).X7(1,:),'c-','LineWidth',2);plot(Targets(1).X8(1,:),'c-','LineWidth',2);
        set(gca,'FontSize',12); set(gcf,'Color','White'); 
        subplot(2,1,2),hold on
        plot(Targets(1).X0(2,:),'k-','LineWidth',2);plot(Targets(1).X00(2,:),'k-','LineWidth',2);
        plot(Targets(1).X1(2,:),'m-','LineWidth',2);
        plot(Targets(1).X2(2,:),'r-','LineWidth',2);plot(Targets(1).X3(2,:),'r-','LineWidth',2);plot(Targets(1).X4(2,:),'r-','LineWidth',2);
        plot(Targets(1).X5(2,:),'b-','LineWidth',2);plot(Targets(1).X6(2,:),'b-','LineWidth',2);
        plot(Targets(1).X7(2,:),'c-','LineWidth',2);plot(Targets(1).X8(2,:),'c-','LineWidth',2);
        hold off
        set(gca,'FontSize',12); set(gcf,'Color','White'); 
        h1=xlabel('Time');
        set([h1],'FontSize',14,'FontName','Times new Roman');
    end
    
    %%  C4F!!
    ll=zeros(1,Runtime);
    repe_Arr=ones(1,Runtime);
    tic;
    for t=1:Runtime
        Num_Targets(t)=size(Targets(t).x,2);
        for i=1:SensorNo
            if numel(SENSOR(i).Observation(t).Y.x)>=ll(t);
                ll(t)=numel(SENSOR(i).Observation(t).Y.x);
                repe_Arr(t)=i;
            end
        end  
    end
    
     for t=1:Runtime
         xout=[];
    %     for repe=1:SensorNo
            repe=repe_Arr(t);
            Dx = SENSOR(repe).Observation(t).Y.x; 
            Dy = SENSOR(repe).Observation(t).Y.y;
            li=zeros(numel(Dx),SensorNo);
            Est=li;
%             li_nearT=li;
%             Est_nearT=li;
            j=0;
%             Dis_Arr=[];
            for i=1:numel(Dx)
                i_Target=[];
                Near_Target=[];
                for repe2=1:SensorNo
                    like=(-(Dx(i)-SENSOR(repe2).Observation(t).Y.x).^2/2/Dx_noise^2)...
                        +(-(Dy(i) - SENSOR(repe2).Observation(t).Y.y).^2/2/Dy_noise^2);
                    if isempty(like)
                        like=-10000;
                    end
                    [lik,ind]=sort(like);
                    li(repe,i,repe2)=lik(end);
                    Est(repe,i,repe2)=ind(end);
%                     li_nearT(repe,i,repe2)=lik(end);
%                     Est_nearT(repe,i,repe2)=ind(end);
                end
                if sum(li(repe,i,:)>Threshod.sigma(t))>=SensorNo*Threshod.Pd
% %     Near_Targets  % not necessary here                     
                    Dis_x=[];
                    Dis_y=[];
                    for repe2=1:SensorNo
                        if ~isempty(SENSOR(repe2).Observation(t).Y.x)
                            Dis_x = [Dis_x,SENSOR(repe2).Observation(t).Y.x(Est(repe,i,repe2))];
                            Dis_y = [Dis_y,SENSOR(repe2).Observation(t).Y.y(Est(repe,i,repe2))];
                            SENSOR(repe2).Observation(t).Y.x(Est(repe,i,repe2))=[];
                            SENSOR(repe2).Observation(t).Y.y(Est(repe,i,repe2))=[];
                        end
                    end               
                    xhat=mean(Dis_x);
                    yhat=mean(Dis_y);
                    j=j+1;
                    xout(:,j)=[xhat;yhat];
                  if t==16&&MC==1      
                    figure(12),hold on
                    if flag==7
                        plot(Dis_x,Dis_y,'bd');hold on
                    end 
                    if flag==6
                        plot(Dis_x,Dis_y,'ms');hold on
                        flag=7;
                    end 
                    if flag==5
                        plot(Dis_x,Dis_y,'cs');hold on
                        flag=6;
                    end 
                    if flag==4
                        plot(Dis_x,Dis_y,'bs');hold on
                        flag=5;
                    end                    
                    if flag==3
                        plot(Dis_x,Dis_y,'mo');hold on
                        flag=4;
                    end
                    if flag==2
                        plot(Dis_x,Dis_y,'co');hold on
                        flag=3;
                    end
                    if flag==1
                        plot(Dis_x,Dis_y,'bo');hold on
                        flag=2;
                    end 
                % observation, truth and estimate
                    for repe=1:SensorNo
                         plot(SENSOR_store(repe).Observation(t).Y.x,SENSOR_store(repe).Observation(t).Y.y,'gx')
                    end
                    x=Targets(t).x;
                    plot(x(1,:),x(2,:),'k.','LineWidth',2);hold on
                    plot(xout(1,:),xout(2,:),'r+','LineWidth',2);
                    box
                  end
                end
            end
%  Miss_detection_compensation   % unecessary, given a large Pd>0.85
    %     end
            Xout(t).xout = xout;
     end
        for t=1:Runtime
            x=Targets(t).x;
            xC4F = Xout(t).xout;
            Tno_C4F(t)=size(xC4F,2);
            if ~isempty(x)
               meand_C4F(t)=ospa_dist(xC4F,x([1,2],:),c,p); % calculate OSPA
            else
               meand_C4F(t)=ospa_dist(xC4F,[],c,p);
            end
        end
     Time_C4F(MC)=toc; 
     
     MC_C4F = MC_C4F+meand_C4F;
     MC_Tno_C4F=MC_Tno_C4F+Tno_C4F;
  end
    
 MC_C4F = MC_C4F/MCtimes;
 MC_Tno_C4F=MC_Tno_C4F/MCtimes;

 mean(Time_C4F)
 mean(MC_C4F)
 save main_C4F

% %%  ======== figures plot===========
% %  mean OSPA plot
% % close all
% figure
% subplot(2,1,2)
% plot(MC_C4F,'r-+','LineWidth',2),
% set(gca,'FontSize',12); set(gcf,'Color','White'); 
% h1=xlabel('Time');
% h2=ylabel('Mean OSPA');%'{\itk}-means clustering',
% set([h1,h2],'FontSize',14,'FontName','Times new Roman');%set(h3,'FontSize',12,'FontName','Times new Roman');
% 
% subplot(2,1,1)
% plot(Num_Targets,'k-','LineWidth',2), hold on, plot(MC_Tno_C4F,'r-+','LineWidth',2),
% set(gca,'FontSize',12); set(gcf,'Color','White'); 
% h1=xlabel('Time');
% h2=ylabel('Mean number of targets');%'{\itk}-means clustering',
% h3=legend('True number of targets','Estimate','location','best');%,'Orientation','horizontal'
% set([h1,h2],'FontSize',14,'FontName','Times new Roman');set(h3,'FontSize',12,'FontName','Times new Roman');


